//regrese _ 2 (ostatni)
//vypocet koeficientu b a r
function [b1,b0,r]=reg_desc(x,y)
    //b1 ... směrnice regresní přímky
    //b0 ... absolutní člen regresní přímky
    //r ... korelační koeficient
    //x ... nezávisle proměnná
    //y ... závisle proměnná
    n=max(size(x));
    if length(y)~=n, 
        disp('wrong lengths of x and y');
        return
    end
    mx=mean(x);
    my=mean(y);
    s2x=variance(x)*(n-1);
    s2y=variance(y)*(n-1);
    sxy=kovariance(x,y)*(n-1);
    b1=sxy/s2x;
    b0=my-b1*mx;
    r=sxy/sqrt(s2x*s2y);
    yp=b1*x+b0;
endfunction

//f-test regrese
function [p_hodnota,T,df_num, df_den]=f_test_reg(x,y)
    //p_hodnota... p-hodnota
    //T ... statistika náhodné veličiny
    //df_num ... stupně volnosti pro čitatele
    //df_num ... stupně volnosti pro jmenovatele
    //x ... nezávisle proměnná
    //y ... závisle proměnná

    n=max(size(x));
    if length(y)~=n
        disp(' Chybne delky vektoru x a y');
        return
    end
    [b1,b0]=reg_desc(x,y);
    yp=b1*x+b0;
    my=mean(y);
    s1=sum((yp-my).^2);       // rozptyl vysvìtlený regresí
    s2=sum((y-yp).^2)/(n-2);  // nevysvětlený rozptyl 
    if s2<1e-8, s2=1e-8; end  //if
    T=s1/s2;
    df_num=1;
    df_den=n-2;
    [P,p_hodnota]=cdff("PQ",T,df_num,df_den);
endfunction  

//f test predikce
function [p_hodnota,T,df_num,df_den]=f_test_pred(y,yp,np)
    //p_hodnota... p-hodnota
    //T ... statistika náhodné veličiny
    //df_num ... stupně volnosti pro čitatele
    //df_num ... stupně volnosti pro jmenovatele
    //y ... závisle proměnná
    //yp ... predikce závisle proměnné
    //np ... počet parametrů regrese (pro b1*x+b0 je np=2)
    if argn(2)<3, np=2; end
    n=length(y);
    my=mean(y);
    s1=sum((yp-my).^2)/(np-1); // rozptyl vysvìtlený regresí
    s2=sum((y-yp).^2)/(n-np);  // nevysvìtlený rozptyl 
    if s2<1e-8, 
        disp('Rozptyl  s2  je nula - vse je vysvetleno');
        s2=1e-8;
    end//if
    T=s1/s2;
    df_num=np-1;
    df_den=n-np;
    [P,p_hodnota]=cdff("PQ",T,df_num,df_den);
endfunction  

//test belosti rezidui
function [p_hodnota,T,z_alpha]=wz_test(y,yp,alpha)
    //p_hodnota ... p-hodnota
    //T ... statistika náhodné veličiny
    //z_alpha ... kritická hodnota
    //alpha ... hladina významnosti 
    //y ... závisle proměnná
    //yp ... predikce závisle proměnné
    x=y-yp;
    x=x(:)';
    me_x=median(x);
    n=size(x,2);
    rozdil=x-me_x;
    b=1;
    rozdil_bez_0=rozdil(rozdil~=0);
    for i=2:size(rozdil_bez_0,2)
        if rozdil_bez_0(i-1)*rozdil_bez_0(i)<0 then
            b=b+1;
        end
    end
    T=(2*b-(n-2))/sqrt(n-1);
    [P,Q]=cdfnor("PQ",T,0,1);
    //
    z_alpha=cdfnor("X",0,1,alpha,1-alpha);
    p_hodnota=P;
endfunction

